#
# cpu-technologie.R, 23 Jan 15
#
# Data from:
#
# Andrew Danowitz and Kyle Kelley and James Mao and John P. Stevenson and Mark Horowitz
# CPU DB: Recording Microprocessor History

source("config.r")


cpu=read.csv(paste0(root, "benchmark/cpu-technologie.csv"), as.is=TRUE)

pal_col=rainbow_hcl(3)

# 0.54307nm is the lattice size for Silicon atoms.
# The lattice has a diamond cubic structure, so individuals atoms
# are closer to each other than this.
plot(jitter(cpu$year), cpu$feature_size*1000/0.54307, log="y", col="red",
	xlim=c(1980, 2015),
	xlab="Year", ylab="Feature size (in Silicon atoms)\n")

