#
# sam3u_temp.R, 21 Feb 15
#
# Data from:
# A case for opportunistic embedded sensing in presence of hardware power variability

source("config.r")

library("plyr")

par(mfcol=c(1,2))

sam_32khz=read.csv(paste0(root, "benchmark/sam3u_32khz_sleep.csv"), as.is=TRUE)

plot_sleep=function(board_num)
{
# Some boards were not tested at some temperatures, so we have NAs

not_miss=subset(sam_32khz, !is.na(sam_32khz[ , board_num]))

par(new=TRUE)
plot(not_miss$temp, not_miss[ , board_num]*1000,
	col=brew_col[board_num], type="b", xaxt="n", yaxt="n",
	xlim=c(20, 60), ylim=c(10, 320),
	xlab="", ylab="")
}

brew_col=rainbow_hcl(10)

plot(1, type="n",
	xlim=c(20, 60), ylim=c(10, 320),
	xlab="Temperature (C)", ylab=expression("Power ("*mu*"W)"))
dummy=sapply(2:11, plot_sleep)
text(40, 20, "Sleeping")

sam_4Mhz=read.csv(paste0(root, "benchmark/sam3u_4Mhz_temp.csv"), as.is=TRUE)

brew_col=rainbow_hcl(10)

plot_power=function(df)
{
av_df=ddply(df, .(temp),
			function(df)
			{
			df$av_pow=mean(df$power)
			return(df)
			})

board_num=df$board[1]
par(new=TRUE)
plot(av_df$temp, av_df$av_pow*1000,
	col=brew_col[board_num], type="l", xaxt="n", yaxt="n",
	xlim=c(-30, 100), ylim=c(8, 10),
	xlab="", ylab="")
}

plot(1, type="n",
	xlim=c(-30, 100), ylim=c(8, 10),
	xlab="Temperature (C)", ylab="Power (mW)")
d_ply(sam_4Mhz, .(board), plot_power)
text(40, 8.05, "4MHz")


